----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:06:04 04/14/2016 
-- Design Name: 
-- Module Name:    serialData - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity serialData is
	Port(
		clk : in std_logic; 
		enable : in std_logic; 		-- Enable um serialDataOut zusammenzusetzen. 
		readWriteBit : in std_logic; 		-- 0 fr Write; 1 fr Read.
		address : in std_logic_vector(2 downto 0); 	-- siehe controlRegister
		writeData : in std_logic_vector(11 downto 0); 		-- siehe controlRegister
		dataOut : out std_logic_vector(15 downto 0) 	-- Daten zur SPI-bertragung.
	); 
end serialData;

----------------------------------------------------------------------
-- In serialData werden die Daten zum Schreiben oder Lesen vorbereitet. 
-- Die SPI Daten sind wie folgt aufgebaut: 
-- Bit 15: definiert ob geschrieben oder gelesen werden soll. 
-- Bits 14 bis 12: beinhalten die Schreib- oder Leseadresse
-- Bits 11 bis 0: beinhalten die zu schreibenden Daten. Soll gelesen werden, werden diese Bits 
-- 					vom Controller ignoriert. Deshalb werden sie hier fest auf "000000000000" gesetzt. 
----------------------------------------------------------------------

architecture Behavioral of serialData is

begin
	
	process 
	begin 
		wait until rising_edge(clk); 
		if enable = '1' then
			if readWriteBit = '0' then 	-- -> Schreiben 
				dataOut <= readWriteBit & address & writeData; 	-- Die zu schreibenden Daten werden mit bergeben
			else  -- readWriteBit = '1'   -- -> Lesen
				dataOut <= readWriteBit & address & "000000000000"; 	-- Beim Lesen sind die Daten egal. Daher werden hier nur 0er bergeben
			end if; 
		end if; 
	end process; 
		
end Behavioral;




